﻿using Coscine.ApiCommons;
using Coscine.ResourceTypes;
using Coscine.WaterbutlerHelper.Services;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.Extensions.DependencyInjection;
using System;
using System.Net.Http;

namespace Coscine.Api.Tree
{
    /// <summary>
    /// standard startup class
    /// </summary>
    public class Startup : AbstractStartup
    {
        /// <summary>
        /// standard startup constructor
        /// </summary>
        public Startup()
        {
        }

        /// <summary>
        /// Configures custom service extension
        /// </summary>
        /// <param name="services">Services</param>
        public override void ConfigureServicesExtension(IServiceCollection services)
        {
            base.ConfigureServicesExtension(services);

            services.AddHttpClient<IDataSourceService, DataSourceService>(client =>
            {
                //TODO: Discuss Timeout value
                client.Timeout = TimeSpan.FromMinutes(30);
            });

            services.AddHttpClient();
        }

        /// <summary>
        /// Add HttpClinetFactory to resource types
        /// </summary>
        /// <param name="app"></param>
        /// <param name="env"></param>
        public override void ConfigureExtensionLate(IApplicationBuilder app, IWebHostEnvironment env)
        {
            base.ConfigureExtensionLate(app, env);

            using var scope = app.ApplicationServices.CreateScope();
            ResourceTypeFactory.HttpClientFactory = scope.ServiceProvider.GetRequiredService<IHttpClientFactory>();
        }
    }
}